SystemOrganization addCategory: #ChooseOrEnter!
SystemOrganization addCategory: 'ChooseOrEnter-ChooseFromBuilder-Core'!

Object subclass: #AbstractChooseOrEnter
	instanceVariableNames: 'chooser enterNewItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChooseOrEnter'!

!AbstractChooseOrEnter methodsFor: 'accessing' stamp: 'HwaJong 10/1/2012 14:32'!
choicePrintingCode: aBlock
chooser choicePrintingCode: aBlock
! !

!AbstractChooseOrEnter methodsFor: 'accessing' stamp: 'HwaJong 10/1/2012 14:32'!
choices: anArray
enterNewItem := EnterNewOne new.
chooser choices: anArray, {enterNewItem}! !

!AbstractChooseOrEnter methodsFor: 'controlling' stamp: 'HwaJong 10/1/2012 14:33'!
goIfChosen: aBlockClosure ifEnteredNew: aBlockClosure2 ifCancelled: aBlockClosure3 
	
	^chooser 
		goIfChosen: [:object| object == enterNewItem 
			ifTrue: [ | enteredNew |
				enteredNew := UIManager default request: 'enter new one'.
				enteredNew isNil ifTrue: [ ^aBlockClosure3 value].
				aBlockClosure2 value: enteredNew ]
			ifFalse: [aBlockClosure value: (chooser choiceMade)]
		] ifCancelled: [aBlockClosure3 value].! !

!AbstractChooseOrEnter methodsFor: 'initialize-release' stamp: 'HwaJong 10/1/2012 14:36'!
initialize
super initialize.
chooser := self classOfChooser new.
chooser titleForChoosingDialog: 'Choose or enter'.! !

!AbstractChooseOrEnter methodsFor: 'accessing' stamp: 'HwaJong 10/1/2012 14:33'!
titleForChoosingDialog: aString
chooser titleForChoosingDialog: aString! !

AbstractChooseOrEnter subclass: #ChooseOrEnter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChooseOrEnter'!

!ChooseOrEnter class methodsFor: 'examples' stamp: 'HwaJong 9/27/2012 12:32'!
exampleArrayOfString
|ce c|
ce := ChooseOrEnter new.
c := {{'hello'}. {'every'}. {'one'}}.


ce choices: c.
ce choicePrintingCode: [:each| each first ].
ce
	goIfChosen: [:choice| choice first ]
	ifEnteredNew: [:string| c := c, {{string}}. string ]
	ifCancelled: [ 'USER CANCELLED!!' ] .! !

!ChooseOrEnter methodsFor: 'initialize-release' stamp: 'HwaJong 10/1/2012 14:35'!
classOfChooser.
^Chooser! !

!ChooseOrEnter methodsFor: 'controlling' stamp: 'HwaJong 10/1/2012 14:34'!
goIfChosen: aBlockClosure ifEnteredNew: aBlockClosure2 ifCancelled: aBlockClosure3 
	
	^chooser 
		goIfChosen: [:object| object == enterNewItem 
			ifTrue: [ | enteredNew |
				enteredNew := UIManager default request: 'enter new one'.
				enteredNew isNil ifTrue: [ ^aBlockClosure3 value].
				aBlockClosure2 value: enteredNew ]
			ifFalse: [aBlockClosure value: (chooser choiceMade)]
		] ifCancelled: [aBlockClosure3 value].! !

AbstractChooseOrEnter subclass: #ChooseOrEnterWithDialogPosition
	instanceVariableNames: 'dialogPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChooseOrEnter'!

!ChooseOrEnterWithDialogPosition class methodsFor: 'examples' stamp: 'HwaJong 9/30/2012 17:11'!
exampleArrayOfString
|ce c|
ce := ChooseOrEnter new.
c := {{'hello'}. {'every'}. {'one'}}.


ce choices: c.
ce choicePrintingCode: [:each| each first ].
ce
	goIfChosen: [:choice| choice first ]
	ifEnteredNew: [:string| c := c, {{string}}. string ]
	ifCancelled: [ 'USER CANCELLED!!' ] .! !

!ChooseOrEnterWithDialogPosition methodsFor: 'initialize-release' stamp: 'HwaJong 10/1/2012 14:35'!
classOfChooser.
^ChooserWithDialogPosition! !

!ChooseOrEnterWithDialogPosition methodsFor: 'accessing' stamp: 'HwaJong 9/30/2012 17:36'!
dialogPosition: aPoint
dialogPosition := aPoint.
chooser dialogPosition: aPoint! !

!ChooseOrEnterWithDialogPosition methodsFor: 'controlling' stamp: 'HwaJong 9/30/2012 17:19'!
goIfChosen: aBlockClosure ifEnteredNew: aBlockClosure2 ifCancelled: aBlockClosure3 
	
	^chooser 
		goIfChosen: [:object| object == enterNewItem 
			ifTrue: aBlockClosure2
			ifFalse: [aBlockClosure value: (chooser choiceMade)]
		] ifCancelled: [aBlockClosure3 value].! !

Object subclass: #AbstractChooser
	instanceVariableNames: 'choices choicePrintingCode titleForChoosingDialog choosingDialog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChooseOrEnter'!

!AbstractChooser methodsFor: 'accessing' stamp: 'HwaJong 10/1/2012 10:25'!
choiceMade
	^ choices at: choosingDialog choice! !

!AbstractChooser methodsFor: 'accessing' stamp: 'HwaJong 10/1/2012 10:25'!
choicePrintingCode: aBlock
choicePrintingCode := aBlock
! !

!AbstractChooser methodsFor: 'accessing' stamp: 'HwaJong 10/1/2012 10:25'!
choices: anArray
choices := anArray! !

!AbstractChooser methodsFor: 'controlling' stamp: 'HwaJong 10/1/2012 10:25'!
goIfChosen: chosenClosure ifCancelled: quitClosure
	self openChoosingDialog.
	^ (self theChoiceMadeIsValid)
		ifTrue: [ chosenClosure value: self choiceMade ]
		ifFalse: [ quitClosure value ]! !

!AbstractChooser methodsFor: 'private' stamp: 'HwaJong 10/1/2012 10:25'!
openChoosingDialog
	choosingDialog := PopupChoiceDialogWindow new
		title: titleForChoosingDialog;
		labels: (self stringofChoices);
		model: nil.
	UIManager default openModal: choosingDialog.
! !

!AbstractChooser methodsFor: 'accessing' stamp: 'HwaJong 10/1/2012 10:25'!
stringofChoices
^choices collect: choicePrintingCode! !

!AbstractChooser methodsFor: 'testing' stamp: 'HwaJong 10/1/2012 10:25'!
theChoiceMadeIsValid
^(choosingDialog choice isNil or: [choosingDialog choice = 0]) not and: [choosingDialog choice between: 1 and: choices size]! !

!AbstractChooser methodsFor: 'accessing' stamp: 'HwaJong 10/1/2012 10:25'!
titleForChoosingDialog: aString
titleForChoosingDialog := aString.! !

AbstractChooser subclass: #Chooser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChooseOrEnter'!

!Chooser class methodsFor: 'examples' stamp: 'HwaJong 9/27/2012 08:21'!
exampleOfChooseMorph
|c|
c := Chooser new.

c choices: World submorphs.
c choicePrintingCode: [:each| (each className), ' ', each extent printString].
c goIfChosen: [:morph| morph activate ] ifCancelled: [ UIManager default inform: 'quit'].! !

!Chooser methodsFor: 'initialize-release' stamp: 'HwaJong 9/27/2012 08:15'!
initialize
super initialize.
choicePrintingCode := [:each| each ].
titleForChoosingDialog := 'Choose one'.! !

AbstractChooser subclass: #ChooserWithDialogPosition
	instanceVariableNames: 'dialogPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChooseOrEnter'!

!ChooserWithDialogPosition class methodsFor: 'examples' stamp: 'HwaJong 9/30/2012 17:36'!
exampleOfChooseMorph
|c|
c := Chooser new.

c choices: World submorphs.
c choicePrintingCode: [:each| (each className), ' ', each extent printString].
c goIfChosen: [:morph| morph activate ] ifCancelled: [ UIManager default inform: 'quit'].! !

!ChooserWithDialogPosition methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/30/2012 17:42'!
dialogPosition: aPoint 
dialogPosition := aPoint ! !

!ChooserWithDialogPosition methodsFor: 'initialize-release' stamp: 'HwaJong 9/30/2012 17:36'!
initialize
super initialize.
choicePrintingCode := [:each| each ].
titleForChoosingDialog := 'Choose one'.! !

!ChooserWithDialogPosition methodsFor: 'private' stamp: 'HwaJong 9/30/2012 17:43'!
openChoosingDialog
	choosingDialog := PopupChoiceDialogWindow new
		title: titleForChoosingDialog;
		labels: (self stringofChoices);
		model: nil.
	choosingDialog position: dialogPosition.
	UIManager default openModal: choosingDialog.
! !

Object subclass: #ChooseFromBuilder
	instanceVariableNames: 'title choices cancelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChooseOrEnter-ChooseFromBuilder-Core'!

!ChooseFromBuilder methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/5/2014 19:39'!
choiceString: aString value: aBlockClosure 
	self choices addLast: aString -> aBlockClosure! !

!ChooseFromBuilder methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/5/2014 19:39'!
choices
	^choices setDefault: #choicesDefault for: self withSetter: #choices:! !

!ChooseFromBuilder methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/5/2014 19:40'!
choices: aCollection 
	choices := aCollection! !

!ChooseFromBuilder methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/5/2014 19:40'!
choicesDefault
	^OrderedCollection new! !

!ChooseFromBuilder methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/5/2014 19:42'!
chooseFromValuesTitle
	|sel|
	sel := UIManager default chooseFrom: self strings values: self values title: title.
	sel ifNil: [ ^cancelBlock value ].
	^sel value value! !

!ChooseFromBuilder methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/5/2014 19:42'!
strings
	^self choices collect: #key! !

!ChooseFromBuilder methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/5/2014 19:38'!
title: aString 
	title := aString! !

!ChooseFromBuilder methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/5/2014 19:42'!
values
	^self choices collect: #value! !

Object subclass: #EnterNewOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChooseOrEnter'!

!EnterNewOne methodsFor: 'error handling' stamp: 'HwaJong 9/30/2012 17:33'!
doesNotUnderstand: aMessage 

	^self stringToDisplay.! !

!EnterNewOne methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/30/2012 17:33'!
printOn: aStream
aStream nextPutAll: self stringToDisplay! !

!EnterNewOne methodsFor: 'as yet unclassified' stamp: 'HwaJong 9/30/2012 17:33'!
stringToDisplay
^'** enter new **'! !
